/***********************************************************

	redDML.cpp

	Version 0.90: 2009/06/04

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include <redDML.h>


/***********************************************************
	ÓIoϐ̎̒`
***********************************************************/

int8_t redDML::system = -1;

uint8_t redDML::dataPin;
uint8_t redDML::clockPin ;
int8_t redDML::swPin = -1 ;

uint8_t redDML::dbPin[5] ;  ;
uint8_t redDML::gDL  ;
uint8_t redDML::gMXR[8] ; /*  */
uint8_t redDML::gMXG[8] ; /*  */

uint8_t redDML::gLED ;
uint8_t redDML::swData ;


/***********************************************************
	FRXgN^
***********************************************************/

redDML::redDML(uint8_t sys)
{
	system = sys ;

	/* vbgtH[Ƃ̃s蓖 */
	switch (sys) {
	  case REDUINO_SP:
	  	dataPin = 6 ;
		clockPin = 7 ;
		dbPin[0] = 14 ;
		dbPin[1] = 15 ;
		dbPin[2] = 16 ;
		dbPin[3] = 17 ;
		dbPin[4] = 11 ;
		swPin = 12 ;
		break ;

	  case REDUINO_VALKYRIE:
	  	dataPin = 6 ;
		clockPin = 7 ;
		dbPin[0] = 14 ;
		dbPin[1] = 15 ;
		dbPin[2] = 16 ;
		dbPin[3] = 17 ;
		break ;

	  case REDUINO_GHOST:
	  	dataPin = 22 ;
		clockPin = 23 ;
		dbPin[0] = 27 ;
		dbPin[1] = 26 ;
		dbPin[2] = 25 ;
		dbPin[3] = 24 ;
		swPin = 2 ;
		break ;

	  case CLCD_BOOSTER:
	  	dataPin = 4 ;
		clockPin = 3 ;
		dbPin[0] = 14 ;
		dbPin[1] = 15 ;
		dbPin[2] = 16 ;
		dbPin[3] = 17 ;
		break ;
	}

	/* XCb`̏Ɣ񊈐 */
	if (system == REDUINO_SP) {
		pinMode(swPin, OUTPUT) ;
		digitalWrite(swPin, HIGH) ;

		pinMode(SP_SW1, INPUT) ;
		pinMode(SP_SW2, INPUT) ;
		digitalWrite(SP_SW1, HIGH) ; // vAbv
		digitalWrite(SP_SW2, HIGH) ;
	} else if (system == REDUINO_GHOST) {
		pinMode(swPin, OUTPUT) ;
		digitalWrite(swPin, HIGH) ;
	} else if (system == REDUINO_VALKYRIE) {
		pinMode(VALKYRIE_SW1, INPUT) ;
		pinMode(VALKYRIE_SW2, INPUT) ;
		digitalWrite(VALKYRIE_SW1, HIGH) ; // vAbv
		digitalWrite(VALKYRIE_SW2, HIGH) ;
	} else if (system == CLCD_BOOSTER) {
		pinMode(CLCD_BOOSTER_SW1, INPUT) ;
		pinMode(CLCD_BOOSTER_SW2, INPUT) ;
		pinMode(CLCD_BOOSTER_SW3, INPUT) ;
		// CLCD-BOOSTER͊OŃvAbv
	}

	/* hbg}gbNXLED\̏ */
	pinMode(dataPin, OUTPUT) ;
	pinMode(clockPin, OUTPUT) ;
	digitalWrite(dbPin[0], HIGH) ;
	digitalWrite(dbPin[1], HIGH) ;
	digitalWrite(dbPin[2], HIGH) ;
	digitalWrite(dbPin[3], HIGH) ;
	pinMode(dbPin[0], OUTPUT) ;
	pinMode(dbPin[1], OUTPUT) ;
	pinMode(dbPin[2], OUTPUT) ;
	pinMode(dbPin[3], OUTPUT) ;

	if (system == REDUINO_SP) {
		digitalWrite(dbPin[4], HIGH) ;
		pinMode(dbPin[4], OUTPUT) ;
		gLED = 0 ;
	}

	/* TIMER2荞݂̐ݒ */
	// TIMER2̃vXP[:128
	sbi(TCCR2B, CS22);
	cbi(TCCR2B, CS21);
	sbi(TCCR2B, CS20);
/*
	// TIMER2̃vXP[:256
	sbi(TCCR2B, CS22);
	sbi(TCCR2B, CS21);
	cbi(TCCR2B, CS20);
*/
	// TIMER2CTC
	cbi(TCCR2B, WGM22);
	sbi(TCCR2A, WGM21);
	cbi(TCCR2A, WGM20);

	OCR2A = 250 - 1 ;

	// TIMER2̊荞݂̊
	sbi(TIMSK2, TOIE2);
}


/***********************************************************
	hbg}gbNXLEDւ̏o
***********************************************************/

/* hbg}gbNXLED̕\NA */
void redDML::clear()
{
	uint8_t i ;

	for (i = 0 ; i < 8 ; i++) {
		gMXR[i] = 0 ;
		gMXG[i] = 0 ;
	}
}


void redDML::clear(uint8_t color)
{
	uint8_t i, r, g ;

	g = (color & DML_DOT_GREEN) ? 0xff : 0x00 ;
	r = (color & DML_DOT_RED) ? 0xff : 0x00 ;

	for (i = 0 ; i < 8 ; i++) {
		gMXR[i] = r ;
		gMXG[i] = g ;
	}
}


/* hbg}gbNXLEDւ̃vbg */
/* 0:A1:ԁA2:΁A3: */
void redDML::plot(uint8_t x, uint8_t y, uint8_t color)
{
	uint8_t w ;

	w = (1 << x) ;

  /* hbgf[^̏ */
	switch (0b11 & color) {
		case DML_DOT_BLACK:
			gMXR[y] &= ~w ;
			gMXG[y] &= ~w ;
			break ;
		case DML_DOT_RED:
			gMXR[y] |= w ;
			gMXG[y] &= ~w ;
			break ;
		case DML_DOT_GREEN:
			gMXR[y] &= ~w ;
			gMXG[y] |= w ;
			break ;
		case DML_DOT_ORANGE:
			gMXR[y] |= w ;
			gMXG[y] |= w ;
			break ;
	}
}


/***********************************************************
	LEDACւ̓óFREDUINO_SP̂
***********************************************************/

void
redDML::ledWrite(uint8_t n)
{
	gLED = n ;
}


void
redDML::ledWrite(uint8_t i, uint8_t n)
{
	gLED &= ~_BV(i) ;

	if (n)
		gLED |= _BV(i) ;
}


int
redDML::ledRead()
{
	return gLED ;
}


int
redDML::swRead(uint8_t i)
{
	return (swData & _BV(i)) ? HIGH : LOW ;
}


/***********************************************************
	_Ci~bN\XV
***********************************************************/


void
redDML::swUpdate()
{
    uint8_t i ;

    for (i = 0; i < NDIGIT; i++) {
        pinMode(dbPin[i], INPUT) ;
        digitalWrite(dbPin[i], HIGH) ; // vAbv܂傤
    }

    if (system == REDUINO_SP) {
        digitalWrite(swPin, LOW) ;

        swData = 0 ;
        if (digitalRead(SP_SW1) == LOW)
            swData |= _BV(0) ;
        if (digitalRead(SP_SW2) == LOW)
            swData |= _BV(1) ;
        if (digitalRead(dbPin[0]) == LOW)
            swData |= _BV(2) ;
        if (digitalRead(dbPin[1]) == LOW)
            swData |= _BV(3) ;
        if (digitalRead(dbPin[2]) == LOW)
            swData |= _BV(4) ;
        if (digitalRead(dbPin[3]) == LOW)
            swData |= _BV(5) ;

        digitalWrite(swPin, HIGH) ;
    } else if (system == REDUINO_GHOST) {
        pinMode(dataPin, INPUT) ;
        digitalWrite(dataPin, HIGH) ;

        digitalWrite(swPin, LOW) ;

        swData = 0 ;
        if (digitalRead(dbPin[0]) == LOW)
            swData |= _BV(0) ;
        if (digitalRead(dbPin[1]) == LOW)
            swData |= _BV(1) ;
        if (digitalRead(dbPin[2]) == LOW)
            swData |= _BV(2) ;
        if (digitalRead(dbPin[3]) == LOW)
            swData |= _BV(3) ;
        if (digitalRead(dataPin) == LOW)
            swData |= _BV(4) ;

        digitalWrite(swPin, HIGH) ;

        pinMode(dataPin, OUTPUT) ;
    }

    for (i = 0; i < NDIGIT; i++)
        pinMode(dbPin[i], OUTPUT) ;
}


void
redDML::Update()
{
	/* f[^XVɔRANeBu */
	if (gDL != 8)
		digitalWrite(dbPin[3], LOW) ;
	else
		digitalWrite(dbPin[4], HIGH) ;

	/* \錅̍XV */
	gDL++ ;
	if (system == REDUINO_SP) {
		if (gDL >= 8 + 1) // 1 for LED array
			gDL = 0 ;
	} else {
		if (gDL >= 8)
			gDL = 0 ;
	}

	// XCb`̓ǂݏo
	if ((gDL == 0) && ((system == REDUINO_SP) || (system == REDUINO_GHOST))) {
		shiftOut(dataPin, clockPin, MSBFIRST, 0x00) ;
		shiftOut(dataPin, clockPin, MSBFIRST, 0x00) ;

		swUpdate() ;
	} else if (system == REDUINO_VALKYRIE) {
		swData = 0 ;
		if (digitalRead(VALKYRIE_SW1) == LOW)
			swData |= _BV(0) ;
		if (digitalRead(VALKYRIE_SW2) == LOW)
			swData |= _BV(1) ;
	} else if (system == CLCD_BOOSTER) {
		swData = 0 ;
		if (digitalRead(CLCD_BOOSTER_SW1) == LOW)
			swData |= _BV(0) ;
		if (digitalRead(CLCD_BOOSTER_SW2) == LOW)
			swData |= _BV(1) ;
		if (digitalRead(CLCD_BOOSTER_SW3) == LOW)
			swData |= _BV(2) ;
	}

	if (gDL != 8) {
		shiftOut(dataPin, clockPin, MSBFIRST, gMXR[gDL]) ; // ԐFo
		shiftOut(dataPin, clockPin, MSBFIRST, gMXG[gDL]) ; // ΐFo

		/* R̕\s̑I */
		digitalWrite(dbPin[0], (gDL & 0b001) ? 1: 0) ;
		digitalWrite(dbPin[1], (gDL & 0b010) ? 1: 0) ;
		digitalWrite(dbPin[2], (gDL & 0b100) ? 1: 0) ;

		/* DML̃RANeBu */
		digitalWrite(dbPin[3], HIGH) ; // RANeBu\ĊJ
	} else {
		shiftOut(dataPin, clockPin, MSBFIRST, gLED) ;

		/* LEDAC̃RANeBu */
		digitalWrite(dbPin[4], LOW) ;
	}
}


/***********************************************************
	TIMER2̊荞݃nh
***********************************************************/


ISR(TIMER2_OVF_vect)
{
	redDML::Update();
}
